//Popovici Ioan Daniel 334ca

#include <avr/io.h>

#define F_CPU 16000000

#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <stdlib.h>

unsigned char column[8] = {PA0, PA1, PA2, PA3, PA4, PA5, PA6, PA7};
unsigned char row[5] = {PD0, PD1, PD2, PD3, PD4};
unsigned char button[6] = {PC1, PC2, PC3, PC4, PC5, PC6};
unsigned char reset = PC1;
unsigned char up = PC2;
unsigned char right = PC3;
unsigned char select = PC4;
unsigned char down = PC5;
unsigned char left = PC6;

//Campurile in care se vor retine miscarile efectuate pentru a
//verifica corectitudinea miscarilor facude de jucator
int move_x[9] = {0,0,0,0,0,0,0,0,0};
int move_y[9] = {0,0,0,0,0,0,0,0,0};
int crt_move = 0;

//Deseneaza semnul ok, folosit atunci cand jucatorul selecteaza corect
//pozitia pe care s-a aprins led-ul;
void draw_ok(){
	int r[7] = {2, 1, 0, 1, 2, 3, 4};
	int c[7] = {1, 2, 3, 4 , 5 ,6 ,7};
	int i, j;
	
	for(i = 0; i < 60; i++){
		for(j = 0; j < 7; j++){
			PORTA = 1 << column[c[j]];
			PORTD = ~(1 << row [r[j]]);
			_delay_ms(2);
		}
		PORTA = 0;
		PORTD = 255;
	}
	

}

//Urmeaza o serie de functii care afiseaza pe matrice numerele
//de la 1 la 9; Aceste numere sunt foloste pentru afisarea
//nivelului la care s-a ajuns;
void draw_one(){
	int r[7] = {2, 3, 4, 3, 2, 1, 0};
	int c[7] = {2, 3, 4, 4, 4, 4, 4};
	int i, j;
	
	for(i = 0; i < 60; i++){
		for(j = 0; j < 7; j++){
			PORTA = 1 << column[c[j]];
			PORTD = ~(1 << row [r[j]]);
			_delay_ms(2);
		}
		PORTA = 0;
		PORTD = 255;
	}
}

void draw_two(){
	int r[11] = {3,4,4,4,3,2,1,0,0,0,1};
	int c[11] = {2,2,3,4,4,4,3,3,4,5,5};
	int i, j;
	
	for(i = 0; i < 60; i++){
		for(j = 0; j < 11; j++){
			PORTA = 1 << column[c[j]];
			PORTD = ~(1 << row [r[j]]);
			_delay_ms(2);
		}
		PORTA = 0;
		PORTD = 255;
	}
}

void draw_three(){
	int r[10] = {4,4,4,3,2,2,1,0,0,0};
	int c[10] = {2,3,4,4,4,3,4,4,3,2};
	int i, j;
	
	for(i = 0; i < 60; i++){
		for(j = 0; j < 10; j++){
			PORTA = 1 << column[c[j]];
			PORTD = ~(1 << row [r[j]]);
			_delay_ms(2);
		}
		PORTA = 0;
		PORTD = 255;
	}
}

void draw_four(){
	int r[10] = {4,3,2,2,2,2,3,1,0,4};
	int c[10] = {2,2,2,3,4,5,4,4,4,4};
	int i, j;
	
	for(i = 0; i < 60; i++){
		for(j = 0; j < 10; j++){
			PORTA = 1 << column[c[j]];
			PORTD = ~(1 << row [r[j]]);
			_delay_ms(2);
		}
		PORTA = 0;
		PORTD = 255;
	}
}

void draw_five(){
	int r[11] = {4,4,4,3,2,2,2,1,0,0,0};
	int c[11] = {5,4,3,3,3,4,5,5,5,4,3};
	int i, j;
	
	for(i = 0; i < 60; i++){
		for(j = 0; j < 11; j++){
			PORTA = 1 << column[c[j]];
			PORTD = ~(1 << row [r[j]]);
			_delay_ms(2);
		}
		PORTA = 0;
		PORTD = 255;
	}
}

void draw_six(){
	int r[12] = {4,4,4,3,2,1,0,0,0,1,2,2};
	int c[12] = {5,4,3,3,3,3,3,4,5,5,5,4};
	int i, j;
	
	for(i = 0; i < 60; i++){
		for(j = 0; j < 12; j++){
			PORTA = 1 << column[c[j]];
			PORTD = ~(1 << row [r[j]]);
			_delay_ms(2);
		}
		PORTA = 0;
		PORTD = 255;
	}
}

void draw_seven(){
	int r[7] = {4,4,4,3,2,1,0};
	int c[7] = {3,4,5,5,4,3,3};
	int i, j;
	
	for(i = 0; i < 60; i++){
		for(j = 0; j < 7; j++){
			PORTA = 1 << column[c[j]];
			PORTD = ~(1 << row [r[j]]);
			_delay_ms(2);
		}
		PORTA = 0;
		PORTD = 255;
	}
}

void draw_eight(){
	int r[13] = {4,4,4,3,2,1,0,0,0,1,2,2,3};
	int c[13] = {5,4,3,3,3,3,3,4,5,5,5,4,5};
	int i, j;
	
	for(i = 0; i < 60; i++){
		for(j = 0; j < 13; j++){
			PORTA = 1 << column[c[j]];
			PORTD = ~(1 << row [r[j]]);
			_delay_ms(2);
		}
		PORTA = 0;
		PORTD = 255;
	}
}

void draw_nine(){
	int r[12] = {4,4,4,3,2,0,0,0,1,2,2,3};
	int c[12] = {5,4,3,3,3,3,4,5,5,5,4,5};
	int i, j;
	
	for(i = 0; i < 60; i++){
		for(j = 0; j < 12; j++){
			PORTA = 1 << column[c[j]];
			PORTD = ~(1 << row [r[j]]);
			_delay_ms(2);
		}
		PORTA = 0;
		PORTD = 255;
	}
}

//Deseneaza seria de swipe-uri care anunta jucatorul ca a gresit
//mutarea si jocul s-a incheiat;
void fail(){
	int i, j, k;
	
	for(k = 0; k < 15; k++){
		for(i = 0; i < 8; i++){
			PORTA = 1 << column[i];
			for(j = 0; j < 5; j++){
				PORTD = ~(1 << row[j]);
				_delay_ms(5);
			}
			PORTA = 0;
			PORTD = 255;
		}
	}
}

void display_level(int level){
	if(level == 1){
		draw_one();
	}
	
	if(level == 2){
		draw_two();
	}
	
	if(level == 3){
		draw_three();
	}
	
	if(level == 4){
		draw_four();
	}
	
	if(level == 5){
		draw_five();
	}
	
	if(level == 6){
		draw_six();
	}
	
	if(level == 7){
		draw_seven();
	}
	
	if(level == 8){
		draw_eight();
	}
		
	if(level == 9){
		draw_nine();
	}
}

//Genereaza random un numar de miscari pe care jucatorul va trebui sa
//le reproduca;
void generate_move(int level){
	int i;
	crt_move = 0;
	
	for(i = 0; i < level; i++){
		move_x[i] = rand() % 8;
		move_y[i] = rand() % 5;
		
		PORTA = 1 << column[move_x[i]];
		PORTD = ~(1 << row[move_y[i]]);
		
		_delay_ms(1300);
		PORTA = 0;
		PORTD = 255;
	}
}


int main(){

	int posx = 0, posy = 0;
	int level = 1;
	
	
	DDRA = 255;
	DDRD = 255;
	
	DDRC = 0;
	PORTC = 255;
	
	while(1){
		//Aprinde led-ul de pe pozitia curenta;
		PORTA = 1 << column[posx];
		PORTD = ~(1 << row[posy]);
		
		//Verifica prin polling daca s-a apasat vreun buton si in
		//caz afirmativ se iau masurile necesare: deplasare, selectare,
		//resetare;
		if((PINC & 1 << up) == 0){
			posy = (posy + 1) % 5;
			_delay_ms(200);
		}
		
		if((PINC & 1 << down) == 0){
			posy = ((posy - 1) >= 0) ? posy - 1 : 4;
			_delay_ms(200);
		}
		
		if((PINC & 1 << left) == 0){
			posx = ((posx - 1) >= 0) ? posx - 1 : 7;
			_delay_ms(200);
		}
		
		if((PINC & 1 << right) == 0){
			posx = (posx + 1) % 8;
			_delay_ms(200);
		}
		
		if((PINC & 1 << reset) == 0){
			posx = 0;
			posy = 0;
			
			if(level == 1){
				display_level(level);
				generate_move(level);
			}else{
				level = 1;
			}
			_delay_ms(100);
		}
		
		if((PINC & 1 << select) == 0){
			if(posx == move_x[crt_move] && posy == move_y[crt_move]){
				draw_ok();
				crt_move++;
				posx = 0;
				posy = 0;
				
				if(crt_move == level){
					level++;
					display_level(level);
					generate_move(level);
				}
			}else{
				fail();
				level = 1;
				posx = 0;
				posy = 0;
			}
		}
		
		PORTA = 0;
		PORTD = 255;
	}
	
	
	return 0;
}